/**
 *         ===============================
 *          JPatch open source 3D modeler
 *         ===============================
 *      Copyright (c)2003 JPatch developer team
 *         see http://jpatch.sourceforge.net
 *
 * This file is part of JPatch.
 *
 * JPatch is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * JPatch is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JPatch; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * @author Heiko Irrgang
 * @version $Id: Mirror.java,v 1.3 2003/06/03 07:47:25 god64 Exp $ $Date: 2003/06/03 07:47:25 $
 * last changed by $Author: god64 $
 *
 * Class: Mirror
 * Hungarian notation prefix: *not yet... my brain dont works in hungarian notation... will go over it when finished*
 *
 **/

import jpatch.*;
import jpatch.plugin.*;
import javax.vecmath.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import plugins.modifiers.*;

// extend modifier plugin
public class Mirror extends jpatch.plugin.Modifier {
	// name used for display in undo and menu
	public static String name=new String("Mirror");
	private Point3f cursor;
	private int axis;
	private JFrame dialog;

	// init super class
	public Mirror(GraphicsWindow gw) {
		super(gw, name);
	}

	// this method gets executed when user selects the plugin
	public void exec() {
		// open axis selection dialog
		MirrorDialog dialog=new MirrorDialog(this);
	}

	// gets startet by axis selection dialog
	public void startMirror() {
		// get the position (Point3f) of the yellow cursor
		cursor=getCursor();
		// execute method mirror(ControlPoint) with all
		// ControlPoints, using automatic undo recorder
		withAllControlPoints("mirror");
	}

	// used by axis selection dialog
	public void setAxis(int axis) {
		this.axis=axis;
	}

	// final method
	public void mirror(ControlPoint cp) {
		switch (this.axis) {
			case 1:
				// only process selected ControlPoints
				if ((cp.getHead()).isSelected)
				{
					cp.position.y=cursor.y+cursor.y-cp.position.y;
					cp.inTangent.y*=-1;
					cp.outTangent.y*=-1;
				}
				break;
			case 2:
				if ((cp.getHead()).isSelected)
				{
					cp.position.z=cursor.z+cursor.z-cp.position.z;
					cp.inTangent.z*=-1;
					cp.outTangent.z*=-1;
				}
				break;
			default:
				if ((cp.getHead()).isSelected)
				{
					cp.position.x=cursor.x+cursor.x-cp.position.x;
					cp.inTangent.x*=-1;
					cp.outTangent.x*=-1;
				}
		}
	}
}
