import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import jpatch.plugin.*;
import plugins.modifiers.*;

public class MirrorDialog extends JFrame {
	private Mirror mirror;
	private JComboBox axisCb;

	public MirrorDialog(Mirror mirror) {
		super("Mirror");
		this.mirror=mirror;
		init();
		setSize(200,100);
		setVisible(true);
	}

	public void init() {
		JButton cancel=new JButton("Cancel");
		cancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
			}
		});
		JButton ok=new JButton("OK");
		ok.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				exec();
			}
		});
		JPanel panMain=new JPanel(true);
		panMain.setLayout(new BoxLayout(panMain, BoxLayout.X_AXIS));
		panMain.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		panMain.add(Box.createHorizontalGlue());
		panMain.add(cancel);
		panMain.add(Box.createRigidArea(new Dimension(10, 0)));
		panMain.add(ok);

		axisCb=new JComboBox(new String[] {"X-Axis", "Y-Axis", "Z-Axis" });
		Container cp=getContentPane();
		JLabel lab=new JLabel("Mirror around:");

		JPanel panOption=new JPanel(true);
		panOption.setLayout(new BoxLayout(panOption, BoxLayout.X_AXIS));
		panOption.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		panOption.add(lab);
		panOption.add(Box.createRigidArea(new Dimension(10, 0)));
		panOption.add(axisCb);
		panOption.add(Box.createHorizontalGlue());

		cp.setLayout(new BorderLayout(0,0));
		cp.add(panOption, BorderLayout.NORTH);
		cp.add(panMain, BorderLayout.SOUTH);

	}

	public void exec() {
		mirror.setAxis(axisCb.getSelectedIndex());
		mirror.startMirror();
		setVisible(false);
	}
}
