/**
 *    Copyright (c)2003 Sascha Ledinsky
 *
 *    This file is part of JPatch.
 *
 *    JPatch is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JPatch is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JPatch; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * @author     Developer: Dan Bishop
 * @version    $Id: BackgroundInfo.java,v 1.3 2003/03/30 23:49:25 danbishop Exp $ $Date: 2003/03/30 23:49:25 $
 */
package jpatch;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;
import java.io.File;

/**
 *  Description of the Class BackgroundInfo
 *
 *  Stores the background image information for the different views allowed
 * @author     dbishop
 * @created    March 30, 2003
 */
class BackgroundInfo {
	/**
	 *  Description of the Fields
	 */
	public boolean displayBackgroundImage = true;
	public Image backgroundImage;
	boolean test;
	public int view;
	protected float frotoscopeXscale;
	protected float frotoscopeYscale;
	protected float frotoscopeXoffset;
	protected float frotoscopeYoffset;
	protected float fWidth, fHeight;
	protected float fscale;
	public String[] strFile = {""};
	/**
	 *Constructor for the BackgroundInfo object
	 *
	 * @param  view  View associated with the image
	 */
	public BackgroundInfo(int view) {
		this.view = view;
		fscale = 1.0f;
		frotoscopeXoffset = 0;
		frotoscopeYoffset = 0;
		backgroundImage = null;
	}


	/**
	 *  Sets the backgroundInfo attribute of the BackgroundInfo object
	 *
	 * @param  owner  Frame that is associated with the image
	 * @param  gp     GraphicsPanel associated with the view
	 */
	void setBackgroundInfo(Frame owner, GraphicsPanel gp) {
		boolean test = false;
		test = RotoscopeInput.getValues(owner, strFile, gp);
		if (test) {
			if (strFile[0] != "") {
				try {
					ImageIcon r = new ImageIcon(strFile[0]);
					backgroundImage = r.getImage();
				} catch (Exception e) {
					System.err.println(e);
				}
				boolean get = true;
				fWidth = backgroundImage.getWidth(null);
				fHeight = backgroundImage.getHeight(null);
				while (get) {
					if (fWidth != -1 && fHeight != -1) {
						get = false;
					}
				}
			}
		}
	}
}

