/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/

package jpatch;

import javax.vecmath.*;
import java.util.*;

public class ChangeCurvesAtomicAction
extends AtomicAction
{
	ArrayList oldCurves;
	ArrayList newCurves;
	Mesh mesh;
	
	public ChangeCurvesAtomicAction(Mesh mesh, ArrayList oldCurves, ArrayList newCurves)
	{
		this.mesh = mesh;
		this.oldCurves = new ArrayList(oldCurves);
		this.newCurves = new ArrayList(newCurves);
	}
	
	public void undo()
	{
		for (int c = 0; c < newCurves.size(); c++) mesh.remove(newCurves.get(c));
		for (int c = 0; c < oldCurves.size(); c++) mesh.add(oldCurves.get(c));	
	}
	
	public void redo()
	{
		for (int c = 0; c < newCurves.size(); c++) mesh.add(newCurves.get(c));
		for (int c = 0; c < oldCurves.size(); c++) mesh.remove(oldCurves.get(c));	
	}
	
	public String getName()
	{
		return "WeldCurvesAtomicAction";
	}
}
