/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*    @Author on last changes: Dan Bishop
*    $id$   $date$
**/

package jpatch;

import java.awt.*;

/**
* main configuration
**/

public class Config
{
	/**
	* colors
	**/
	static final Color backgroundColor = new Color(64,64,92);
	static final Color border1Color = new Color(255,255,255);
	static final Color border2Color = new Color(128,128,128);
	static final Color border3Color = new Color(0,0,0);
	static final Color border4Color = new Color(192,192,192);
	static final Color activeCurveColor = new Color(168,168,168);
	static final Color curveColor = new Color(88,88,112);
	static final Color gridColor = new Color(32,32,64);
	static final Color minorGridColor = new Color(54,54,82);
	static final Color controlPointColor = new Color(255,0,0);
	static final Color selectedControlPointColor = new Color(64,255,64);
	static final Color textColor = new Color(224,224,255);
	static final Color selectorColor = new Color(255,255,0);
	static final Color cursorColor = new Color(255,255,0,192);
	static final Color tangentColor = new Color(0,255,255);
	static final Color activeSegmentColor = new Color(255,255,0);
	static final Color semiTransparentDark = new Color(0,0,0,128);
	static final Color semiTransparentLight = new Color(255,255,255,128);
	static final RGB[] layerColors = new RGB[]
	{
		new RGB(0.5f,0.5f,1.0f),
		new RGB(1.0f,0.0f,0.0f),
		new RGB(0.0f,0.7f,0.0f),
		new RGB(0.0f,0.0f,1.0f),
		new RGB(1.0f,1.0f,0.0f),
		new RGB(1.0f,0.0f,1.0f),
		new RGB(0.0f,1.0f,1.0f),
		new RGB(1.0f,0.5f,0.0f),
		new RGB(0.5f,0.5f,0.5f),
	};	
	/**
	* path
	**/
	static final String defaultPath = "f:\\java\\cat2\\";	
	/**
	* misc
	**/
	static final int undoStackCapacity = 20;     
	static final int layers = 8;
	static String dir = "";
	/**
	* about
	**/
	
	// Added the Rhino license information, made about public
	// Mar 31, 2003
	// Dan Bishop			
	public static final String about =  "JPatch Version 0.2.1\n" + "compiled " + VersionInfo.compileTime + "\n\nCopyright  2003 The JPatch-Team\nCopyright  2003 Sascha Ledinsky\n\n" + 
					"This program is free software; you can redistribute it and/or modify\n" +        
					"it under the terms of the GNU General Public License as published by\n" +        
					"the Free Software Foundation; either version 2 of the License, or\n" +           
					"(at your option) any later version.\n" +                                         
					"\n" +                                                                             
					"This program is distributed in the hope that it will be useful,\n" +             
					"but WITHOUT ANY WARRANTY; without even the implied warranty of\n" +              
					"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n" +               
					"GNU General Public License for more details.\n" +                                
					"\n" +                                                                             
					"You should have received a copy of the GNU General Public License\n" +           
					"along with this program if not, write to the Free Software\n" +                 
					"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n\n" +
					"Rhino 1.5.1 Plugin --- js.jar (Javascript):\n" + 
					"The Rhino code included with the plug-in in js.jar includes no modifications.\n"+
					"The plug-in is accompanied by software developed by Mozilla as part of\n" +  
					" the Rhino project.  Source code for the Rhino binaries is available at\n" +
					"http://www.mozilla.org/rhino/ under terms of the Netscape Public License 1.1.\n" +
					"\n" + 
					"Java3D vecmath package -- javax.vecmath:\n" +
					"This disrtibution contains the inofficial Java3D vecmath package by\n" + 
					"Kenji Hiranabe. See http://objectclub.esm.co.jp/vecmath/\n";
	
	public static final String team =
		"<html><table>" +
		"<tr><th colspan=2 align=left><u>The JPatch-Team are (in alphabetical order):</u></th></tr>" +
		"<tr><td>Dan Bishop</td><td>Developer</td></tr>" +
		"<tr><td>Robert Hemby</td><td>Consultant / Tester</td></tr>" +
		"<tr><td>Heiko Irrgang</td><td>Developer</td></tr>" +
		"<tr><td>Sascha Ledinsky</td><td>Project Administrator / Developer</td></tr>" +
		"<tr><td>Giovanni Martone</td><td>Project Administrator / Consultant</td></tr>" +
		"<tr><th colspan=2 align=left><u>Other Contributors:</u></th></tr>" +
		"<tr><td colspan=2>Gregg Patton</td></tr>";

	
}       
        
        
        
        
        
        
        
        
        
        
        
        
