package jpatch;

import java.util.*;
import javax.vecmath.*;
import javax.media.j3d.*;
import javax.swing.*;
import com.sun.j3d.utils.universe.*; 
import com.sun.j3d.utils.geometry.*;

public class J3DMesh
extends Shape3D
{
	//int uSteps = 4;
	//int vSteps = 4;
	String s = JOptionPane.showInputDialog("Number of subdivisions:","4");
	int uSteps = (new Integer(s)).intValue();
	int vSteps = uSteps;
	protected ArrayList patches;			
	public J3DMesh(ArrayList patches)
	{
		this.patches = patches;
		PolygonAttributes p = new PolygonAttributes();
		p.setCullFace(PolygonAttributes.CULL_NONE);
		p.setBackFaceNormalFlip(true);
		Material m = new Material();
		m.setDiffuseColor(0.0f,0.0f,1.0f);
		m.setSpecularColor(0.0f,0.0f,0.0f);
		m.setShininess(1.0f);
		Appearance a = new Appearance();
		a.setPolygonAttributes(p);
		a.setMaterial(m);
		setAppearance(a);
		setGeometry(meshGeometry());
	}
	private Geometry meshGeometry()
	{
		TriangleArray triangleArray;
		ArrayList polygons = new ArrayList();
		ArrayList colors = new ArrayList();
		ArrayList normals = new ArrayList();
		for (int p = 0; p < patches.size(); p++)
		{
			Patch patch = (Patch)patches.get(p);
			ArrayList bcpl = patch.getBicubicPatches();
			for (int b = 0; b < bcpl.size(); b++)
			{
				Vector3f[] cps = (Vector3f[])bcpl.get(b);
				//Point3f displayCP = new Point3f();
				
				
				
				Point3f[][] pos = new Point3f[uSteps + 1][vSteps + 1]; 
				Vector3f[][] normal = new Vector3f[uSteps + 1][vSteps + 1];
				for (int u = 0; u <= uSteps; u++)
				{
					float uu = (float)u/(float)uSteps;
					for (int v = 0; v <= vSteps; v++)
					{
						float vv = (float)v/(float)vSteps;
						pos[u][v] = patch.getPoint(uu,vv,cps);
						normal[u][v] = patch.getNormal(uu,vv,cps);
					}
				}
				Color3f color = Config.layerColors[patch.getLayer()].getColor3f();
				for (int u = 0; u < uSteps; u++)
				{
					for (int v = 0; v < vSteps; v++)
					{
						polygons.add(pos[u][v]);
						polygons.add(pos[u+1][v]);
						polygons.add(pos[u+1][v+1]);
						polygons.add(pos[u+1][v+1]);
						polygons.add(pos[u][v+1]);
						polygons.add(pos[u][v]);
						Vector3f s = new Vector3f(pos[u+1][v]);
						Vector3f t = new Vector3f(pos[u][v+1]);
						s.sub(pos[u][v]);
						t.sub(pos[u][v]);
						Vector3f n = new Vector3f();
						n.cross(s,t);
						colors.add(color);
						colors.add(color);
						colors.add(color);
						colors.add(color);
						colors.add(color);
						colors.add(color);
						Vector3f uv = new Vector3f(normal[u][v]);
						Vector3f u1v = new Vector3f(normal[u+1][v]);
						Vector3f u1v1 = new Vector3f(normal[u+1][v+1]);
						Vector3f uv1 = new Vector3f(normal[u][v+1]);
						//uv.scale(-1);
						//u1v.scale(-1);
						//u1v1.scale(-1);
						//uv1.scale(-1);
						normals.add(uv);
						normals.add(u1v);
						normals.add(u1v1);
						normals.add(u1v1);
						normals.add(uv1);
						normals.add(uv);
						
					
						
						
					}
				}	
			}
		}
		Point3f[] coords = new Point3f[polygons.size()];
		Color3f[] cols = new Color3f[colors.size()];
		Vector3f[] norms = new Vector3f[normals.size()];
		
		for (int p = 0; p < polygons.size(); p++)
		{
			coords[p] = (Point3f)polygons.get(p);
			cols[p] = (Color3f)colors.get(p);
			norms[p] = (Vector3f)normals.get(p);
		}
		System.out.println(coords.length);
		triangleArray = new TriangleArray (coords.length,
		                        TriangleArray.COORDINATES
		                    	| TriangleArray.COLOR_3
		                        | TriangleArray.NORMALS
		                        );
		
		triangleArray.setCoordinates(0, coords);
		triangleArray.setColors(0,cols);
		triangleArray.setNormals(0,norms);
		
		return triangleArray;	
		
	}
}