/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/

package jpatch;

import javax.vecmath.*;

public class NewControlPointAtomicAction
extends AtomicAction
{
	protected Curve curve;
	protected ControlPoint cp;
	protected int index;
	
	public NewControlPointAtomicAction(Curve curve, ControlPoint cp)
	{
		this.curve = curve;
		this.cp = cp;
	}
	
	public void undo()
	{
		index = curve.indexOf(cp);
		curve.remove(cp);
	}
	
	public void redo()
	{
		if (index != -1) curve.add(index,cp);
	}
	
	public String getName()
	{
		return "NewControlPointAtomicAction";
	}
}
