/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/

package jpatch;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.vecmath.*;
import java.awt.geom.*;

public class OptionDialog
extends JDialog
implements ActionListener, CaretListener
{
	private static boolean code;
	private static OptionDialog optionDialog;
	private int num;
	private JButton okButton = new JButton("OK");
	private JButton cancelButton = new JButton("Cancel");
	private JTextField[] field;
	private String[] value;
	public OptionDialog(Frame owner, String name, String[] attribute, String[] value)
	{
		super(owner, name, true);
		this.value = value;
		num = attribute.length;
		field = new JTextField[num];
		getContentPane().setLayout(new GridLayout(num + 1,2));
		for (int n = 0; n < num; n++)
		{
			getContentPane().add(new JLabel(attribute[n]));
			field[n] = new JTextField(value[n]);
			field[n].addCaretListener(this);
			//field[n].addActionListener(this);
			getContentPane().add(field[n]);
		}	
		okButton.addActionListener(this);
		cancelButton.addActionListener(this);
		getContentPane().add(okButton);
		getContentPane().add(cancelButton);
		setLocationRelativeTo(owner);
		pack();
		show();
	}
	public void actionPerformed(ActionEvent event)
	{
		if (event.getSource() == okButton)
		{
			code = true;
			dispose();
		}
		if (event.getSource() == cancelButton)
		{
			code = false;
			dispose();
		}
	}
	
	public void caretUpdate(CaretEvent event)
	{
		for (int n = 0; n < num; n++)
		{
			if (event.getSource() == field[n])
			{
				value[n] = field[n].getText();
			}
		}
	}
	
	public static boolean getValues(Frame owner, String name, String[] attribute, String[] value)
	{
		optionDialog = new OptionDialog(owner, name, attribute, value);
		return code;
	}
}