/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*@author developer on changes : Dan Bishop
*@version $Id: PopupML.java,v 1.13 2003/05/12 07:00:29 god64 Exp $ $Date: 2003/05/12 07:00:29 $
**/

package jpatch;
import jpatch.plugin.*;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
//import javax.media.j3d.*;

public class PopupML
extends MouseAdapter
{
	protected GraphicsPanel gp;
	protected int button;
	protected MyPopup popup;
	protected JFileChooser fc;
	
	public PopupML(GraphicsPanel gp, int button)
	{
		this.gp = gp;
		this.button = button;
		popup = new MyPopup(gp);
	}	

	public void mousePressed(MouseEvent event)
	{
		if (button == event.getButton())
		{
			//System.out.println("popup***");
			if (!popup.isShowing())
			{
				popup = new MyPopup(gp);
			 	popup.show(gp,event.getX(),event.getY());
			}
			
			else
			{
				popup.setVisible(false);
			}
		}
	}
	
	class MyPopup
	extends JPopupMenu
	implements ActionListener
	{
		GraphicsPanel gp;
		JMenu view;
		ButtonGroup viewGroup;
		ButtonGroup layerGroup;
		JMenu grid;
		JMenu show;
		JMenu selection;
		JMenu edit;
		JMenu test;
		JMenu jmnuBackgroundImage;
		JMenu plugins;
		JMenu layer;
		JMenu activeLayer;
		JMenu visibleLayers;
		JMenu moveToLayer;
		JMenuItem menuItem;
		JCheckBoxMenuItem checkBoxMenuItem;
		JRadioButtonMenuItem radioButtonMenuItem;
		MyPopup(GraphicsPanel gp)
		{
			this.gp = gp;
			
			view = new JMenu("view");
			viewGroup = new ButtonGroup();
			radioButtonMenuItem = new JRadioButtonMenuItem("front");
			radioButtonMenuItem.setSelected(gp.viewMode == GraphicsPanel.FRONT);
			view.add(radioButtonMenuItem);
			viewGroup.add(radioButtonMenuItem);
			radioButtonMenuItem.addActionListener(this);
			radioButtonMenuItem = new JRadioButtonMenuItem("back");
			radioButtonMenuItem.setSelected(gp.viewMode == GraphicsPanel.BACK);
			view.add(radioButtonMenuItem);
			viewGroup.add(radioButtonMenuItem);
			radioButtonMenuItem.addActionListener(this);
			radioButtonMenuItem = new JRadioButtonMenuItem("left");
			radioButtonMenuItem.setSelected(gp.viewMode == GraphicsPanel.LEFT);
			view.add(radioButtonMenuItem);
			viewGroup.add(radioButtonMenuItem);
			radioButtonMenuItem.addActionListener(this);
			radioButtonMenuItem = new JRadioButtonMenuItem("right");
			radioButtonMenuItem.setSelected(gp.viewMode == GraphicsPanel.RIGHT);
			view.add(radioButtonMenuItem);
			viewGroup.add(radioButtonMenuItem);
			radioButtonMenuItem.addActionListener(this);
			radioButtonMenuItem = new JRadioButtonMenuItem("top");
			radioButtonMenuItem.setSelected(gp.viewMode == GraphicsPanel.TOP);
			view.add(radioButtonMenuItem);
			viewGroup.add(radioButtonMenuItem);
			radioButtonMenuItem.addActionListener(this);
			radioButtonMenuItem = new JRadioButtonMenuItem("bottom");
			radioButtonMenuItem.setSelected(gp.viewMode == GraphicsPanel.BOTTOM);
			view.add(radioButtonMenuItem);
			viewGroup.add(radioButtonMenuItem);
			radioButtonMenuItem.addActionListener(this);
			radioButtonMenuItem = new JRadioButtonMenuItem("birds eye");
			radioButtonMenuItem.setSelected(gp.viewMode == GraphicsPanel.BIRDSEYE);
			view.add(radioButtonMenuItem);
			viewGroup.add(radioButtonMenuItem);
			menuItem = new JMenuItem("Reset All");
			menuItem.addActionListener(this);
			view.add(menuItem);
			radioButtonMenuItem.addActionListener(this);
			
			grid = new JMenu("grid");
			checkBoxMenuItem = new JCheckBoxMenuItem("show");
			checkBoxMenuItem.setState(gp.showGrid);
			grid.add(checkBoxMenuItem);
			checkBoxMenuItem.addActionListener(this);
			checkBoxMenuItem = new JCheckBoxMenuItem("snap");
			checkBoxMenuItem.setState(gp.gw.snapToGrid);
			grid.add(checkBoxMenuItem);
			checkBoxMenuItem.addActionListener(this);
			menuItem = new JMenuItem("set spacing");
			grid.add(menuItem);
			menuItem.addActionListener(this);
			
			show = new JMenu("show");
			checkBoxMenuItem = new JCheckBoxMenuItem("control points");
			checkBoxMenuItem.setState(gp.showControlPoints);
			show.add(checkBoxMenuItem);
			checkBoxMenuItem.addActionListener(this);
			checkBoxMenuItem = new JCheckBoxMenuItem("curves");
			checkBoxMenuItem.setState(gp.showCurves);
			show.add(checkBoxMenuItem);
			checkBoxMenuItem.addActionListener(this);
			
			// Add the ability to show background images if not BirdsEye view
			// Changed to have own entry for background image
			//@author developer on changes : Dan Bishop
			//@version $Id: PopupML.java,v 1.13 2003/05/12 07:00:29 god64 Exp $ $Date: 2003/05/12 07:00:29 $
			if(gp.viewMode != GraphicsPanel.BIRDSEYE)
			{
				jmnuBackgroundImage = new JMenu("Background Image");
				menuItem = new JMenuItem("Set");
				jmnuBackgroundImage.add(menuItem);
				menuItem.addActionListener(this);
				JCheckBoxMenuItem checkBoxMenuItem = new JCheckBoxMenuItem("Display");
				checkBoxMenuItem.setState(gp.gw.backgroundInfo[gp.viewMode].displayBackgroundImage);
				jmnuBackgroundImage.add(checkBoxMenuItem);
				checkBoxMenuItem.addActionListener(this);
				menuItem = new JMenuItem("Scale");
				jmnuBackgroundImage.add(menuItem);
				menuItem.addActionListener(this);
				menuItem = new JMenuItem("Translate");
				jmnuBackgroundImage.add(menuItem);
				menuItem.addActionListener(this);
			}
			
			selection = new JMenu("selection");
			menuItem = new JMenuItem("select all");
			selection.add(menuItem);
			menuItem.addActionListener(this);
			menuItem = new JMenuItem("select layer");
			selection.add(menuItem);
			menuItem.addActionListener(this);
			menuItem = new JMenuItem("select none");
			selection.add(menuItem);
			menuItem.addActionListener(this);
			menuItem = new JMenuItem("select connected");
			selection.add(menuItem);
			menuItem.addActionListener(this);
			menuItem = new JMenuItem("invert selection");
			selection.add(menuItem);
			menuItem.addActionListener(this);
			menuItem = new JMenuItem("delete selected points");
			selection.add(menuItem);
			menuItem.addActionListener(this);
			menuItem = new JMenuItem("detach selected points");
			selection.add(menuItem);
			menuItem.addActionListener(this);
			moveToLayer = new JMenu("move selcted points to");
			for (int l = 0; l < Config.layers; l++)
			{
				menuItem = new JMenuItem("layer " + (l + 1));
				menuItem.setActionCommand("move_to_layer " + l);
				menuItem.addActionListener(this);
				if (gp.gw.visibleLayers[l]) checkBoxMenuItem.setSelected(true);
				else checkBoxMenuItem.setSelected(false);
				moveToLayer.add(menuItem);
			}
			selection.add(moveToLayer);
			
			edit = new JMenu("edit");
			String undoName = gp.mesh.undoStack.getUndoName();
			String redoName = gp.mesh.undoStack.getRedoName();
			menuItem = new JMenuItem("undo " + undoName);
			menuItem.setEnabled(undoName != "");
			menuItem.setActionCommand("undo");
			edit.add(menuItem);
			menuItem.addActionListener(this);
			menuItem = new JMenuItem("redo " + redoName);
			menuItem.setEnabled(redoName != "");
			menuItem.setActionCommand("redo");
			edit.add(menuItem);
			menuItem.addActionListener(this);

			JMenu editMirror = new JMenu("mirror");
			menuItem.addActionListener(this);
			menuItem = new JMenuItem("mirror x");
			editMirror.add(menuItem);
			menuItem.addActionListener(this);
			menuItem = new JMenuItem("mirror y");
			editMirror.add(menuItem);
			menuItem.addActionListener(this);
			menuItem = new JMenuItem("mirror z");
			editMirror.add(menuItem);
			menuItem.addActionListener(this);
			edit.add(editMirror);
			
			layer = new JMenu("layer");
			layerGroup = new ButtonGroup();
			activeLayer = new JMenu("active layer");
			visibleLayers = new JMenu("visible layers");
			for (int l = 0; l < Config.layers; l++)
			{
				radioButtonMenuItem = new JRadioButtonMenuItem("layer " + (l + 1));
				radioButtonMenuItem.setActionCommand("activate_layer " + l);
				radioButtonMenuItem.addActionListener(this);
				activeLayer.add(radioButtonMenuItem);
				layerGroup.add(radioButtonMenuItem);
				if (gp.gw.activeLayer == l) radioButtonMenuItem.setSelected(true);
				checkBoxMenuItem = new JCheckBoxMenuItem("layer " + (l + 1));
				checkBoxMenuItem.setActionCommand("toggle_layer_visibility " + l);
				checkBoxMenuItem.addActionListener(this);
				if (gp.gw.visibleLayers[l]) checkBoxMenuItem.setSelected(true);
				else checkBoxMenuItem.setSelected(false);
				visibleLayers.add(checkBoxMenuItem);
			}
			menuItem = new JMenuItem("all");
			menuItem.setActionCommand("all_layers_visible");
			menuItem.addActionListener(this);
			visibleLayers.add(menuItem);
			menuItem = new JMenuItem("none");
			menuItem.setActionCommand("no_layers_visible");
			menuItem.addActionListener(this);
			visibleLayers.add(menuItem);
			menuItem = new JMenuItem("invert");
			menuItem.setActionCommand("invert_visible_layers");
			menuItem.addActionListener(this);
			visibleLayers.add(menuItem);
				
			layer.add(activeLayer);
			layer.add(visibleLayers);
			
			plugins=new JMenu("plugins");
			String[] modNames=gp.gw.pluginManager.getModifiers();
			for (int i=0;i<modNames.length;i++) {
				menuItem=new JMenuItem(modNames[i]);
				menuItem.addActionListener(gp.gw.pluginManager);
				plugins.add(menuItem);
			}

			add(edit);
			add(view);
			add(layer);
			add(grid);
			add(show);
			add(selection);
			add(plugins);
			
			if(gp.viewMode != GraphicsPanel.BIRDSEYE)
			{
				add(jmnuBackgroundImage);
			}
		}
		public void actionPerformed(ActionEvent event)
		{
			String cmd = event.getActionCommand();
			//System.out.println(cmd);
			if (cmd == "control points") gp.showControlPoints = !gp.showControlPoints;
			if (cmd == "curves") gp.showCurves = !gp.showCurves;
			if (cmd == "show") gp.showGrid = !gp.showGrid;
			if (cmd == "Display")gp.gw.backgroundInfo[gp.viewMode].displayBackgroundImage = !gp.gw.backgroundInfo[gp.viewMode].displayBackgroundImage;
			if (cmd == "front") gp.setView(GraphicsPanel.FRONT);
			if (cmd == "back") gp.setView(GraphicsPanel.BACK);
			if (cmd == "left") gp.setView(GraphicsPanel.LEFT);
			if (cmd == "right") gp.setView(GraphicsPanel.RIGHT);
			if (cmd == "top") gp.setView(GraphicsPanel.TOP);
			if (cmd == "bottom") gp.setView(GraphicsPanel.BOTTOM);
			if (cmd == "birds eye") gp.setView(GraphicsPanel.BIRDSEYE);
			
			// Added option to reset to original views
			// @Author: Dan Bishop
			// Mar 31,2003
			if (cmd == "Reset All"){
				gp.mesh.gw.graphicsPanels[0].setView(GraphicsPanel.FRONT);
				gp.mesh.gw.graphicsPanels[1].setView(GraphicsPanel.LEFT);
				gp.mesh.gw.graphicsPanels[2].setView(GraphicsPanel.TOP);
				gp.mesh.gw.graphicsPanels[3].setView(GraphicsPanel.BIRDSEYE);
				gp.mesh.gw.repaint();
			}
			if (cmd == "snap") gp.gw.snapToGrid = !gp.gw.snapToGrid;
			if (cmd == "set spacing") gp.gridSpacing = (new Float(JOptionPane.showInputDialog("new grid spacing:",Float.toString(gp.gridSpacing)))).floatValue();
			if (cmd == "select all") gp.mesh.selectAll();
			if (cmd == "select layer") gp.mesh.selectLayer();
			if (cmd == "select none") gp.mesh.unselectAll();
			if (cmd == "select connected") gp.mesh.selectConnected();
			if (cmd == "invert selection") gp.mesh.invertSelection();
			if (cmd == "delete selected points") gp.mesh.deleteSelected();
			if (cmd == "detach selected points") gp.mesh.detachSelected();
			if (cmd == "undo") gp.mesh.undo();
			if (cmd == "redo") gp.mesh.redo();
			if (cmd == "mirror x") gp.mesh.mirrorSelected(Mesh.DIRECTION_X);
			if (cmd == "mirror y") gp.mesh.mirrorSelected(Mesh.DIRECTION_Y);
			if (cmd == "mirror z") gp.mesh.mirrorSelected(Mesh.DIRECTION_Z);
			if (cmd == "compute Patches") gp.mesh.computePatches();
			
			// Handle the cmds for the background image
			//@author developer on changes : Dan Bishop
			//@version $Id: PopupML.java,v 1.13 2003/05/12 07:00:29 god64 Exp $ $Date: 2003/05/12 07:00:29 $
			if (cmd == "Set")
			{
				gp.gw.backgroundInfo[gp.viewMode].setBackgroundInfo(gp.mesh.frame,gp);

			}
			if (cmd == "Scale")
			{
				gp.removeAllMouseListeners();
				gp.removeAllMouseMotionListeners();
				gp.setPopupEnable(true);
				gp.addMouseListener(new ZoomImageML(gp,MouseEvent.BUTTON1));
			}
			if (cmd == "Translate")
			{
				gp.removeAllMouseListeners();
				gp.removeAllMouseMotionListeners();
				gp.setPopupEnable(true);
				gp.addMouseListener(new TranslateImageML(gp,MouseEvent.BUTTON1));
			}
			if (cmd.startsWith("activate_layer"))
			{
				String[] part = cmd.split("\\s");
				int layer = (new Integer(part[1])).intValue();
				//System.out.println(layer);
				gp.gw.activeLayer = layer;
				gp.mesh.unselectAll();
			}
			if (cmd.startsWith("toggle_layer_visibility"))
			{
				String[] part = cmd.split("\\s");
				int layer = (new Integer(part[1])).intValue();
				gp.gw.visibleLayers[layer] = !gp.gw.visibleLayers[layer];
			}
			if (cmd.startsWith("move_to_layer"))
			{
				String[] part = cmd.split("\\s");
				int layer = (new Integer(part[1])).intValue();
				gp.mesh.layerSelected(layer);
			}
			if (cmd == "all_layers_visible") for (int l = 0; l < Config.layers; l++) gp.gw.visibleLayers[l] = true;
			if (cmd == "no_layers_visible") for (int l = 0; l < Config.layers; l++) gp.gw.visibleLayers[l] = false;
			if (cmd == "invert_visible_layers") for (int l = 0; l < Config.layers; l++) gp.gw.visibleLayers[l] = !gp.gw.visibleLayers[l];
			if (cmd == "compute")
			{
				gp.mesh.computePatches();
			}
			
			// Moved to MainMenu
			// @Author : Dan Bishop
			// Mar 31, 2003
/*			if (cmd == "launch Java3D")
			{
				//Shap scene  = gp.mesh.sceneGraph();
				gp.mesh.j3dFrame = new Java3DFrame(gp.mesh.getShape());
				gp.mesh.j3dFrame.setVisible(true);
			}
			if (cmd == "javascript console")
			{
				try
				{
					TestScript.run(gp.mesh);
				}
				catch(Exception e)
				{
					System.out.println(e);
					System.out.println("Javascript aborted");
				}
			}
			if (cmd == "run javascript")
			{
				if (Config.dir == "") fc = new JFileChooser();
				else fc = new JFileChooser(Config.dir);
				if ( fc.showOpenDialog(gp.mesh.frame) == JFileChooser.APPROVE_OPTION)
				{
					File file = fc.getSelectedFile();
					Config.dir = file.getParent();
					String filename = file.getPath();
					try
					{
						TestScript.load(gp.mesh,filename);
					}
					catch(Exception e)
					{
						System.out.println(e);
						System.out.println("Javascript aborted");
					}
				}
			}*/
			gp.gw.repaint();
		}
		
	}
}
