/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/

package jpatch;

import java.awt.*;
import java.awt.event.*;

public class RotateViewML
extends MouseAdapter
{
	protected GraphicsPanel gp;
	protected int button;
	protected RotateViewMML motionListener;
	
	public RotateViewML(GraphicsPanel gp,int button)
	{
		this.gp = gp;
		this.button = button;
		gp.removeAllMouseMotionListeners();
	}	

	public void mousePressed(MouseEvent event)
	{
		if (button == event.getButton())
		{
			motionListener = new RotateViewMML(gp,event.getX(),event.getY());
			gp.addMouseMotionListener(motionListener);
			gp.setCursor(new Cursor(Cursor.MOVE_CURSOR));
		}
	}

	public void mouseReleased(MouseEvent event)
	{
		if (button == event.getButton())
		{
			gp.removeMouseMotionListener(motionListener);
			gp.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
	}

	class RotateViewMML
	extends MouseMotionAdapter
	{
		protected int mouseX;
		protected int mouseY;
		protected GraphicsPanel gp;
		
		public RotateViewMML(GraphicsPanel gp, int mouseX, int mouseY)
		{
			this.gp = gp;
			this.mouseX = mouseX;
			this.mouseY = mouseY;
		}

		public void mouseDragged(MouseEvent event)
		{
			int deltaX = event.getX() - mouseX;
			int deltaY = event.getY() - mouseY;
			mouseX = event.getX();
			mouseY = event.getY();
			gp.viewMode = GraphicsPanel.BIRDSEYE;
			gp.viewDef.rotateX += (float)deltaY/300;
			gp.viewDef.rotateY += (float)deltaX/300;
			if (gp.viewDef.rotateX > Math.PI/2) gp.viewDef.rotateX = (float)Math.PI/2.0f;
			if (gp.viewDef.rotateX < -Math.PI/2) gp.viewDef.rotateX = -(float)Math.PI/2.0f;
			gp.axisView = false;
			gp.repaint();
		}
	}
}