/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/

package jpatch;

import javax.vecmath.*;

public class TangentChangeAtomicAction
extends AtomicAction
{
	ControlPoint cp;
	protected boolean oldPeak;
	protected boolean newPeak;
	protected float oldCurvature;
	protected float newCurvature;
	
	public TangentChangeAtomicAction(ControlPoint cp, boolean peak, float curvature)
	{
		this.cp = cp;
		this.oldPeak = cp.peak;
		this.oldCurvature = curvature;
		this.newPeak = peak;
		this.newCurvature = cp.inCurvature;
	}
	
	public void undo()
	{
		cp.peak = oldPeak;
		cp.inCurvature = oldCurvature;
		cp.outCurvature = oldCurvature;
	}
	
	public void redo()
	{
		cp.peak = newPeak;
		cp.inCurvature = newCurvature;
		cp.outCurvature = newCurvature;
	}
	
	public String getName()
	{
		return "TangentChangeAtomicAction";
	}
}
