package jpatch;

import org.mozilla.javascript.*;
import java.io.*;
import javax.vecmath.*;
//import java.awt.*;

public class TestScript
{
	public static void run(Mesh mesh)
	throws JavaScriptException
	{
		BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
		String line = "";
		String source = "";
		Context cx = Context.enter();
		try
		{
			System.out.println("Javascript ready, enter commands, end with \\q");
			//Scriptable scope = cx.initStandardObjects(null);
			Scriptable scope = new ImporterTopLevel(cx);
			//ImporterTopLevel.importPackage(cx,scope,
			//Scriptable jsArgs = Context.toObject(mesh, scope);
			scope.put("mesh",scope,Context.toObject(mesh,scope));
			scope.put("out",scope,Context.toObject(System.out,scope));
			cx.evaluateString(scope,"importPackage(Packages.jpatch);","<cmd>",1,null);
			/*
			scope.put("Point",scope,Context.toObject(Point3f,scope));
			scope.put("Vector",scope,Context.toObject(Vector3f,scope));
			scope.put("CP",scope,Context.toObject(ControlPoint,scope));
			scope.put("Curve",scope,Context.toObject(Curve,scope));
			*/
			while (!line.startsWith("\\q"))
			{
				try
				{
					line = input.readLine();
				}
				catch(Exception e)
				{
					System.err.println(e);
				}
				source = source + line + "\n";
				if (!line.startsWith("\\q") && cx.stringIsCompilableUnit(source))
				{
					Object result = cx.evaluateString(scope, source, "<cmd>", 1, null);
					System.err.println(cx.toString(result));
					source = "";
				}
			}
			System.out.println("Javascript finished");
		}
		finally
		{
			Context.exit();
		}
	}

	public static void load(Mesh mesh, String filename, boolean resource)
	throws JavaScriptException
	{
		BufferedReader file;
		String errorString = "";
		String line;
		Vector3f[] points = new Vector3f[0];
		int[] layers = new int[0];
		ControlPoint[] heads = new ControlPoint[0];
		boolean[] intToBoolean = { false,true };
		int version = 1;
		try
		{
			try
			{
				if (resource) { 
					file = new BufferedReader(new InputStreamReader(ClassLoader.getSystemResourceAsStream(filename)));
				} else {
					file = new BufferedReader(new FileReader(filename));
				}
				Context cx = Context.enter();
		
				Scriptable scope = new ImporterTopLevel(cx);
			
				scope.put("mesh",scope,Context.toObject(mesh,scope));
				scope.put("out",scope,Context.toObject(System.out,scope));
			
				Object result = cx.evaluateReader(scope, file, "<cmd>", 1, null);
				//System.err.println(cx.toString(result));
			}
			catch(Exception e)
			{
				System.err.println(e);
			}
			
		}
		finally
		{
			Context.exit();
		}
	}
}
 