/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*@author developer on changes : Dan Bishop
*@version $Id: TranslateViewML.java,v 1.4 2003/03/31 00:57:42 danbishop Exp $ $Date: 2003/03/31 00:57:42 $
*
**/

package jpatch;

import java.awt.*;
import java.awt.event.*;

public class TranslateViewML
extends MouseAdapter
{
	protected GraphicsPanel gp;
	protected int button;
	protected TranslateViewMML motionListener;
	
	public TranslateViewML(GraphicsPanel gp,int button)
	{
		this.gp = gp;
		this.button = button;
		gp.removeAllMouseMotionListeners();
	}	

	public void mousePressed(MouseEvent event)
	{
		if (button == event.getButton())
		{
			gp.setPopupEnable(false);
			motionListener = new TranslateViewMML(gp,event.getX(),event.getY());
			gp.addMouseMotionListener(motionListener);
			gp.setCursor(new Cursor(Cursor.MOVE_CURSOR));
		}
	}

	public void mouseReleased(MouseEvent event)
	{
		if (button == event.getButton())
		{
			gp.setPopupEnable(true);
			gp.removeMouseMotionListener(motionListener);
			gp.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
	}

	class TranslateViewMML
	extends MouseMotionAdapter
	{
		protected int mouseX;
		protected int mouseY;
		protected GraphicsPanel gp;
		
		public TranslateViewMML(GraphicsPanel gp, int mouseX, int mouseY)
		{
			this.gp = gp;
			this.mouseX = mouseX;
			this.mouseY = mouseY;
		}

		public void mouseDragged(MouseEvent event)
		{
			int deltaX = event.getX() - mouseX;
			int deltaY = event.getY() - mouseY;
			mouseX = event.getX();
			mouseY = event.getY();
			gp.viewDef.translateX += deltaX/gp.windowScale;
			gp.viewDef.translateY += deltaY/gp.windowScale;
			gp.repaint();
		}
	}
}