/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/

package jpatch;

import java.util.*;

/**
* this stores a undoable user action as ArrayList of atomic actions
**/
public class UndoAction
extends ArrayList
{
	protected String name;
	
	/*
	public void add(AtomicAction atomicAction)
	{
		super.add(atomicAction);
		System.out.println ("undo " + name + " recorded " + atomicAction.getName());
	}
	*/
	
	public UndoAction(String name)
	{
		this.name = name;
	}
	
	/**
	* undo each recorded atomic action, last to first
	**/
	public void undo()
	{
		for (int i = size() - 1; i >= 0; i--) ((AtomicAction)get(i)).undo();
	}
	
	/**
	* redo each recorded atomic action, first to last
	**/
	public void redo()
	{
		for (int i = 0; i < size(); i++) ((AtomicAction)get(i)).redo();
	}
	
	public String getName()
	{
		return name;
	}
	
	public void rename(String name)
	{
		this.name = name;
	}
}
	