/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
package jpatch;
import java.io.File;

public class Utils
{
	public final static String sPatch = "spt";
	public final static String tiff   = "tiff";
	public final static String tif    = "tif";
	public final static String gif   = "gif";
	public final static String jpeg   = "jpeg";
	public final static String jpg   = "jpg";
	public final static String png   = "png";

	public static String getExtension(File f)
	{
		String ext = null;
		String s = f.getName();
		int i = s.lastIndexOf('.');
		
		if (i > 0 &&  i < s.length() - 1)
		{
			ext = s.substring(i+1).toLowerCase();
		}
		return ext;
	}
	public static float optimumCurvature(int segments) {
		double theta = Math.PI/(double)segments;
		double x0 = Math.cos(theta);
		double y0 = Math.sin(theta);
		double x1 = (4-Math.cos(theta))/3;
		double y1 = ((1-Math.cos(theta))*(Math.cos(theta)-3))/3/Math.sin(theta);
		double d = Math.sqrt((x1-x0)*(x1-x0)+(y1-y0)*(y1-y0));
		double l = 4*Math.sin(theta);
		double c = d/l;
		return (float)c;
	}
}       
        
        
        
        
        