/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/

package jpatch;

import javax.vecmath.*;

public class WeldCurvesAtomicAction
extends AtomicAction
{
	Curve oldCurveA;
	Curve oldCurveB;
	Curve newCurve;
	Mesh mesh;
	
	protected Vector3f oldPosition = new Vector3f();
	protected Vector3f newPosition = new Vector3f();
	
	public WeldCurvesAtomicAction(Mesh mesh, Curve oldCurveA, Curve oldCurveB, Curve newCurve)
	{
		this.mesh = mesh;
		this.oldCurveA = oldCurveA;
		this.oldCurveB = oldCurveB;
		this.newCurve = newCurve;
	}
	
	public void undo()
	{
		mesh.remove(newCurve);
		mesh.add(oldCurveA);
		mesh.add(oldCurveB);
	}
	
	public void redo()
	{
		mesh.remove(oldCurveA);
		mesh.remove(oldCurveB);
		mesh.add(newCurve);
	}
	
	public String getName()
	{
		return "WeldCurvesAtomicAction";
	}
}
