/**
*    Copyright (c)2003 Sascha Ledinsky
*
*    This file is part of JPatch.
*
*    JPatch is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JPatch is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with JPatch; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*@author developer on changes : Dan Bishop
*@version $Id: ZoomViewML.java,v 1.4 2003/03/31 00:57:05 danbishop Exp $ $Date: 2003/03/31 00:57:05 $
**/

package jpatch;

import java.awt.event.*;

public class ZoomViewML
extends MouseAdapter
{
	protected GraphicsPanel gp;
	protected int button;
	protected ZoomViewMML motionListener;
	public ZoomViewML(GraphicsPanel gp,int button)
	{
		this.gp = gp;
		this.button = button;
		gp.removeAllMouseMotionListeners();
	}	
	
	public void mousePressed(MouseEvent event)
	{
		if (button == event.getButton())
		{	
			motionListener = new ZoomViewMML(gp,event.getX(),event.getY());
			gp.addMouseMotionListener(motionListener);
	
		}
	}

	public void mouseReleased(MouseEvent event)
	{
		if (button == event.getButton())
		{
			gp.removeMouseMotionListener(motionListener);
/*			// Changed to switch back to the previous action-mode
			// after scaling the rotoscope-image
			// Autor: Sascha Ledinsky
			// was iZoomOption = -1;
			if (iZoomOption == ZOOM_IMAGE) {
				gp.gw.changeAction(gp.gw.action);
			}
			iZoomOption = ZOOM_DEFAULT;
			// end of change*/
		}
	}

	class ZoomViewMML
	extends MouseMotionAdapter
	{
		protected int mouseX;
		protected int mouseY;
		protected GraphicsPanel gp;
		protected GraphicsWindow gw;
		
		public ZoomViewMML(GraphicsPanel gp, int mouseX, int mouseY)
		{
			this.gp = gp;
			this.mouseX = mouseX;
			this.mouseY = mouseY;
		}

		public void mouseDragged(MouseEvent event)
		{
			int deltaX = event.getX() - mouseX;
			int deltaY = event.getY() - mouseY;
			mouseX = event.getX();
			mouseY = event.getY();
			float ds = (1+((float)deltaX-(float)deltaY)/200);
			if (ds < 0.2) ds = (float)0.2;
			if (ds > 5) ds = (float)5;
			gp.viewDef.scale *= ds;
			gp.repaint();
		}
	}
}