/**
 *         ===============================
 *          JPatch open source 3D modeler
 *         ===============================
 *      Copyright (c)2003 JPatch developer team
 *         see http://jpatch.sourceforge.net
 *
 * This file is part of JPatch.
 *
 * JPatch is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * JPatch is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JPatch; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * @author Heiko Irrgang
 * @version $Id: PluginIO.java,v 1.1 2003/05/12 06:54:57 god64 Exp $ $Date: 2003/05/12 06:54:57 $
 * last changed by $Author: god64 $
 *
 * Class: PluginIO
 * Hungarian notation prefix: *not yet... my brain dont works in hungarian notation... will go over it when finished*
 *
 **/

package jpatch.plugin;

import java.lang.reflect.Method;

public class PluginIO {
	private Class c;
	private Method mWrite;
	private Method mRead;
	private Object instance;
	private String name;

	public void setClass(Class c) {
		this.c=c;
	}

	public void setWriteMethod(Method m) {
		this.mWrite=m;
	}

	public void setReadMethod(Method m) {
		this.mRead=m;
	}

	public void setInstance(Object o) {
		this.instance=o;
	}

	public void setName(String name) {
		this.name=name;
	}

	public void write(String filename) {
		try {
			this.mWrite.invoke(this.instance, new Object[] {filename});
		} catch (java.lang.Exception e) {
			System.err.println("plugin execution failed (write())");
		}
	}

	public void read(String filename) {
		try {
			this.mRead.invoke(this.instance, new Object[] {filename});
		} catch (java.lang.Exception e) {
			System.err.println("plugin execution failed (read())");
		}
	}
}
