/**
 *         ===============================
 *          JPatch open source 3D modeler
 *         ===============================
 *      Copyright (c)2003 JPatch developer team
 *         see http://jpatch.sourceforge.net
 *
 * This file is part of JPatch.
 *
 * JPatch is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * JPatch is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JPatch; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * @author Heiko Irrgang
 * @version $Id: PluginLoader.java,v 1.3 2003/06/01 19:45:04 god64 Exp $ $Date: 2003/06/01 19:45:04 $
 * last changed by $Author: god64 $
 *
 * Class: PluginLoader
 * Hungarian notation prefix: *not yet... my brain dont works in hungarian notation... will go over it when finished*
 *
 **/

package jpatch.plugin;

import java.io.*;

public class PluginLoader extends ClassLoader {
	private String fileprefix=new String("");
	private String pathprefix=new String("");

	public void setFilePrefix(String prfx) {
		this.fileprefix=prfx;
	}

	public void setPathPrefix(String prfx) {
		this.pathprefix=prfx;
	}

	protected Class findClass(String name) {
		File f = new File (pathprefix+"plugins/"+fileprefix, name+".class");

		int size = (int)f.length();
		byte buff[] = new byte[size];

		FileInputStream fis;
		try {
			fis = new FileInputStream(f);
		} catch (java.io.FileNotFoundException e) {
			System.out.println("Filenotfound: "+f.getAbsolutePath());
			return null;
		}
		DataInputStream dis = new DataInputStream (fis);

		try {
			dis.readFully (buff);
			dis.close();
		} catch (java.io.IOException e) {
			return null;
		}


		return defineClass(name, buff, 0, buff.length);
	}
}
