/**
 *         ===============================
 *          JPatch open source 3D modeler
 *         ===============================
 *      Copyright (c)2003 JPatch developer team
 *         see http://jpatch.sourceforge.net
 *
 * This file is part of JPatch.
 *
 * JPatch is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * JPatch is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JPatch; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * @author Heiko Irrgang
 * @version $Id: PluginModifier.java,v 1.2 2003/05/18 08:03:06 god64 Exp $ $Date: 2003/05/18 08:03:06 $
 * last changed by $Author: god64 $
 *
 * Class: PluginModifier
 * Hungarian notation prefix: *not yet... my brain dont works in hungarian notation... will go over it when finished*
 *
 **/

package jpatch.plugin;

import java.lang.reflect.Method;

public class PluginModifier {
	private Class c;
	private Method m;
	private Object instance;
	private String name;

	public void setName(String name) {
		this.name=name;
	}

	public String getName() {
		return this.name;
	}

	public void setClass(Class c) {
		this.c=c;
	}

	public void setMethod(Method m) {
		this.m=m;
	}

	public void setInstance(Object o) {
		this.instance=o;
	}

	public void exec() {
		try {
			this.m.invoke(this.instance, new Class[] {});
		} catch (java.lang.Exception e) {
			System.err.println("plugin execution failed: "+e);
		}
	}
}
