/**
*
* JPatch demo javascript
*
* This script asks for radius and number of segments
* and creates a sphere
*
**/

importPackage(Packages.jpatch);
importPackage(Packages.javax.vecmath);
var layer = mesh.gw.activeLayer;
var attribute = java.lang.reflect.Array.newInstance(java.lang.String,3);
var value = java.lang.reflect.Array.newInstance(java.lang.String,3);
attribute[0] = "radius:";
attribute[1] = "latitude segments:";
attribute[2] = "longitude segments:";
value[0] = "5.0";
value[1] = "4";
value[2] = "4";
test = OptionDialog.getValues(mesh.frame,"Create sphere",attribute,value);
if (test)
{
	mesh.unselectAll();
        var radius = (new java.lang.Float(value[0]).floatValue());
	var lat_segments = (new java.lang.Integer(value[1]).intValue());
	var long_segments = (new java.lang.Integer(value[2]).intValue())*2;
	var curves = java.lang.reflect.Array.newInstance(Curve,lat_segments);
	var latCurvature = Utils.optimumCurvature(long_segments);
	var longCurvature = Utils.optimumCurvature(lat_segments*2);
	top = new ControlPoint(new Vector3f(0,radius,0),false,layer);
	top.isSelected = true;
	bottom = new ControlPoint(new Vector3f(0,-radius,0),false,layer);
	bottom.isSelected = true;
	for (latitude = 1; latitude < lat_segments; latitude++)
	{
		r = Math.sin(latitude/lat_segments*Math.PI)*radius;
	        curve = new Curve();
		y = Math.cos(latitude/lat_segments*Math.PI)*radius;	
		for (longitude = 0; longitude < long_segments; longitude++)
		{
			x = Math.cos(longitude/long_segments*2*Math.PI)*r;
			z = Math.sin(longitude/long_segments*2*Math.PI)*r;
			cp = new ControlPoint(new Vector3f(x,y,z),false,layer);
			cp.inCurvature = latCurvature;
			cp.outCurvature = latCurvature;
			cp.isSelected = true;
			curve.add(cp);
		}
		curve.closed = true;
		mesh.add(curve);
		curves[latitude] = curve;
	}
	for (longitude = 0; longitude < long_segments/2; longitude++)
	{
		curve = new Curve();
		if (longitude == 0) curve.add(top);
		else
		{
			ncp = new ControlPoint(top);
			ncp.inCurvature = longCurvature;
			ncp.outCurvature = longCurvature;
			ncp.weldedTo = top;
			curve.add(ncp);
		}
		for (latitude = 1; latitude < lat_segments; latitude++)
		{
			c = curves[latitude];
			cp = c.get(longitude);
			ncp = new ControlPoint(cp);
			ncp.inCurvature = longCurvature;
			ncp.outCurvature = longCurvature;
			ncp.weldedTo = cp;
			curve.add(ncp);
		}
		if (longitude == 0) curve.add(bottom);
		else
		{
		        ncp = new ControlPoint(bottom);
		        ncp.inCurvature = longCurvature;
			ncp.outCurvature = longCurvature;
        		ncp.weldedTo = bottom;
        		curve.add(ncp);
		}
		for (latitude = lat_segments - 1; latitude > 0; latitude--)
                {
                        c = curves[latitude];
                        cp = c.get(longitude + long_segments/2);
                        ncp = new ControlPoint(cp);
                        ncp.inCurvature = longCurvature;
			ncp.outCurvature = longCurvature;
                        ncp.weldedTo = cp;
                        curve.add(ncp);
                }
		curve.closed = true;
		mesh.add(curve);
	}
}
 

